# Coveo ImageFieldValue Component (CoveoImageFieldValue)

This component renders an image from a URL retrieved in a given `field`.

A typical use case of this component is to display product images in the context of commerce.

Available since

  September 2019 Release (v2.7023)

Result template component

  This component is intended to be used in result templates

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- field
- height
- srcTemplate
- width

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts:41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts:52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts:61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts:328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts:410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts:270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts:294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts:282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts:23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts:18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts:286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts:278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts:274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts:290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts:28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts:343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### field

field: IFieldOption

- Defined in ui/FieldImage/ImageFieldValue.ts:43

Required. The name of a field whose value is the URL of the image to display.

Note: The component uses the value of this field to set the `src` attribute of the `img` HTML tag it generates.

Required

  Specifying a value for this option is required for the component to work

Markup configuration example(s) :

    data-field='@foo'

### height

height: number

- Defined in ui/FieldImage/ImageFieldValue.ts:55

The height of the image (in pixels).

Note: The component uses this value to set the `height` attribute of the `img` HTML tag it generates.

Markup configuration example(s) :

    data-height='10'

### srcTemplate

srcTemplate: string

- Defined in ui/FieldImage/ImageFieldValue.ts:81

A template literal from which to generate the `img` tag's `src` attribute value.

This option overrides the `field` option value.

The template literal can reference any number of fields from the parent result. It can also reference global scope properties.

Examples:

- The following markup generates an `src` value such as `http://uri.com?id=itemTitle`:

    <a class='CoveoImageFieldValue' data-src-template='${clickUri}?id=${raw.title}'></a>

- The following markup generates an `src` value such as `localhost/fooBar`:

    <a class='CoveoImageFieldValue' data-src-template='${window.location.hostname}/{Foo.Bar}'></a>

Default value is `undefined`.

Markup configuration example(s) :

    data-src-template='foo'

### width

width: number

- Defined in ui/FieldImage/ImageFieldValue.ts:49

The width of the image (in pixels).

Note: The component uses this value to set the `width` attribute of the `img` HTML tag it generates.

Markup configuration example(s) :

    data-width='10'

## Constructors

### constructor

- new ImageFieldValue(element: HTMLElement, options: IImageFieldValue, bindings?: IComponentBindings, result?: IQueryResult): ImageFieldValue

- Overwrites Component.constructor

  - Defined in ui/FieldImage/ImageFieldValue.ts:82

  Creates a new ImageFieldValue.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: IImageFieldValue

    The options for the ImageFieldValue component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The result to associate the component with.

  #### Returns ImageFieldValue